<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" />
  <title>ITEA-JS ADVANCED - LESSON 2: CLASSWORK 2</title>
  <link rel="stylesheet" href="css/style.min.css" />
</head>
<body>
  <div class="wrap">
    <div class="testBlock hover">
      <button class="iButton" id="mouseHover">1. Hover!</button>
      <ul id="hoverResult" class="resultBlock">
        <li class="red">Hovered!</li>
        <li class="blue">Hovered!</li>
      </ul>
    </div>

    <div class="testBlock click">
      <button class="iButton" id="mouseClick">2. Click for do things</button>
      <div id="clickResult" class="resultBlock one two three four five six"></div>
    </div>

    <div class="testBlock random">
      <button class="iButton" id="mouseLight">3. Click for turn on lights</button>
      <div id="lightResult" class="resultBlock"></div>
    </div>

    <div class="testBlock keyboard">
      <button class="iButton" id="keyboardButton">4. Press any key</button>
      <div id="keyboardResult" class="resultBlock key-colors"></div>
    </div>

  </div>

  <script>
    /*

      Поработаем немного с ивентами:
      onmouseenter
      onclick
      oncontextmenu
      onkeydown

      Задание:
      На каждую из конопок назначить действие которое будет выполнять следующее действие:
      1.На ховер(onmouseenter) повесить обработчик который будет при каждом наведении
        на кнопку будет выводить в блок результатом елемент li с текстом "hovered!"
        у которого будет один из следующих класов:
        red blue green orange purple

      2.На кнопку клика (onclick) повесить обработчик который будет удалять классы с
        блока с результатом по очереди в таком порядке:

        six > two > three > four > one > five
        после того как блок окажется пустым, добавить их в порядке возрастания
        one > two > three ... > six

      3. На кнопку клика (Light) повесить обработчик, который будет выводить в 
      блок с результатом (lightResult) поочередно один из цветов светофора:
      Цикл: Off -> Red -> Yellow -> Green -> Off

      4. На кнопку с обработчиком нажатия (onkeydown) повесить обработчик который будет:

        - Выводить в блок с результатом(keyboardResult) число нажатий на любую из клавиш клавиатуры.
        - Давать блоку (keyboardResult) классы, которые соотсветствуют числу кликов:

        Н-р:
        1 -> one
        3 -> three
        5 -> five
        11 -> one one
        115 -> one one five



    */

    let mouseHover = document.getElementById('mouseHover');
    let mouseClick = document.getElementById('mouseClick');
    let mouseLight = document.getElementById('mouseLight');
    let keyboardButton = document.getElementById('keyboardButton');

    // Task 2.1.
    mouseHover.onmouseenter = function(){
      let colors = ['red', 'blue', 'green', 'orange', 'purple'];
      let num = getRandomIntInclusive(0, 4);
      let li = document.createElement('li');
      li.innerText = 'hovered!';
      li.className = colors[num];
      document.getElementById('hoverResult').appendChild(li);
    }

    function getRandomIntInclusive(min, max) {
      min = Math.ceil(min);
      max = Math.floor(max);
      return Math.floor(Math.random() * (max - min + 1)) + min;
    }

    // Task 2.2.
    let clickIndex = 0;
    let direction = true;

    mouseClick.onclick = function(){
      let removeClasses = ['six', 'two', 'three', 'four', 'one', 'five'];
      let addClasses = ['one', 'two', 'three', 'four', 'five', 'six'];

      let selectedArray = direction ? removeClasses : addClasses;
      let op = direction ? 'remove' : 'add';

      changeBlock(selectedArray, op);
    }

    function changeBlock(array, op) {
      let block2 = document.getElementById('clickResult');
      block2.classList[op](array[clickIndex]);

      clickIndex++;
      if (clickIndex === array.length) {
        direction = !direction;
        clickIndex = 0;
      }
    }

    // Task 2.3.
    let colors = ['Off', 'Red', 'Yellow', 'Green'];
    let colorIndex = 0;

    mouseLight.onclick = function(e){
        let block = document.getElementById('lightResult');
        block.innerText = colors[colorIndex];
        colorIndex++;
        if (colorIndex === colors.length) {
          colorIndex = 0;
        }
    }

    // Task 2.4.
    let counter = 0;
    let numbers = ['zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine'];
    let block = document.getElementById('keyboardResult');
    let initText = block.innerText;
    let initClasses = block.className;

    keyboardButton.onkeydown = function(e){
      counter++;
    }

    keyboardButton.addEventListener('blur', function () {
      if (!counter) {
        return;
      }

      block.innerText = counter;

      let counterString = new String(counter);
      for (let i=0; i < counterString.length; i++) {
        let index = counterString[i];
        block.classList.add(numbers[index]);
      }
    });

    keyboardButton.addEventListener('focus', function () {
      counter = 0;
      block.innerText = initText;
      block.className = initClasses;
    });

  </script>
</body>
</html>
